
## introduction 

Ultimate Screen Access (USA) connects the open source NVDA screen reader with the powerful magnification capabilities present in Windows 10. This creates a very powerful package that can provide a good solution in various situations. 

## System requirements

To use USA successfully, the following system requirements apply:

* Windows 10 version 1709 (Fall Creators Update) or newer) (32-bit and 64-bit)
* Processor: 2 GHz i5 dual core processor or similar
* Intel graphics card (NVIDIA is not recommended)
* 4 GB Ram. 8 GB recommended
* 200MB free hard disk space, excluding voice synthesizer
* Installed copy of NVDA 2022.1 or later

## Installation

### NVDA
Note: In order to successfully use Ultimate Screen Access, it is necessary to have an installed version of NVDA.
In a portable version of NVDA (for example, from a USB stick), the mouse will not function properly when the screen is enlarged.

If you do not yet have NVDA, you can download it from [nvaccess.org](http://www.nvaccess.org/). On the download page you will find the link to the latest version of NVDA. By running the downloaded file, a temporary copy of NVDA is started. Then you will be asked whether you want to install NVDA, create a portable copy or continue to use the temporary copy. Choose install and follow the on-screen instructions.

### Ultimate Screen Access

USA comes as an NVDA add-on. Installation is therefore performed via the "Manage Add-ons" item under Tools in the NVDA menu. 

In the "Manage Add-ons" dialog box, you will find a list of all installed Add-ons that are currently in your user configuration folder. For each Add-on the package name, status, version and author is displayed. To install a previously acquired USA Add-on press the "Install" button in this window. Then look for the USA installation file (a file with the extension "*.nvda-addon"). As soon as you click on the "Open" button, the installation procedure will begin. 

When the installation starts, NVDA will ask you if you really want to install Ultimate Screen Access. Since the functionality of Add-ons within NVDA is not restricted, which in theory means that access is gained to your personal data as well as the whole system, it is important to only install Add-ons that you trust. In other words, only install a version of Ultimate Screen Access that comes from Babbage. Once USA is installed, NVDA needs to be restarted to activate the Add-on. Without a restart, USA will display an "Install" status. 

## Usage
For the use of NVDA we refer to the NVDA manual. This can be found in the NVDA menu, which can be opened by pressing NVDA+N or clicking on the NVDA_icon in the Windows system tray. Then select ""User Manual"" from the "Help" menu.

### USA enable
If the USA NVDA add-on is installed, you can enable USA as follows.

1. Open the NVDA menu.
2. Navigate to "Ultimate Screen Access"
3. Select "Enable USA"

### Adjust USA settings
When USA is enabled, the following settings can be changed within the menu item "simple settings USA" of the "Ultimate Screen Access" menu, or within the "Visual" tab of the NVDA_ settings.

#### Step Level
The magnification step level to be used when zooming in or out. A step level of 0.1 means that the screen gets enlarged with 10% every time.

#### Enable soft edges around images to improve magnification quality
This setting will in most cases increase the quality of text.
When this option is turned off, the content of the screen is literally enlarged.
When enabled, the software tries to adjust the edges of images and letters to present a more natural result.

#### Follow the system focus
When enabled, USA will ensure that the system focus is always on the screen as much as possible.
For example, the system focus is changed when you use the keyboard to navigate through a dialog box or make a selection from a list.

#### Focus Limitation
The settings in this picklist allow you to set where the system focus is positioned on the screen.

* When you choose "centered", USA will always try to display the focus in the centre of the screen as much as possible, unless the item that has the focus is at the edge of the screen.
* When you choose a percentage within the screen edges, such as 25%, USA will always try to display the system focus within 25% of the screen edges.
* When you choose unconstrained, USA will at least try to place the focus on the screen, but there are no restrictions on where the focus is ultimately located.
* When you choose relative, USA will try to display the focus in the enlarged reality at the same position it is in the unlarged reality. If a button or input field would be at 25% of the left and top edge on an unzoomed screen, USA tries to place the element at the same position in the enlarged reality.

#### Follow foreground window changes
When you switch between different active windows, for example by using the keyboard combination alt+tab, there is a foreground window change. 
When this option is enabled, USA tries to ensure that the relevant information from the foreground window is immediately visible.

#### Follow the navigator object
When this option is enabled, USA will ensure that the object you selected with the NVDA object navigation is visible on the screen. For more information on the navigator object, see the NVDA manual.

#### Follow the system cursor
The system cursor is the usually blinking cursor visible in text fields, for example in Word or Notepad. When this option is enabled, USA will follow the position of the cursor and ensure that the part of the text where the cursor is blinking is always visible.
This option also applies to NVDA's browse mode.

#### System Cursor Limitation
This setting determines the boundary of the system cursor within the edges of the screen. With this option, the choices are the same as the Focus Limitation option.

#### Follow reading cursor
When this option is enabled, USA will ensure that the text where the reading cursor of NVDA is located is visible on the screen. For more information on the reading cursor, please refer to the NVDA manual.
For the position of the cursor of NVDA browsing mode, the setting for the system cursor is used.

For text tracking during continuous reading (NVDA+ arrow down or NVDA+A), it can be set in USA that the words read aloud are also tracked. In addition, in the settings it can also be chosen whether a rectangle is to be projected over the spoken word and whether the caret must be moved with it. The colour and thickness of the rectangle can also be adjusted in the settings menu.

#### Follow mouse pointer
When this option is enabled, USA will follow the position of the mouse and make sure the mouse is always visible.
Disabling this option results in the mouse pointer disappearing from view when it falls outside the edge of the enlarged reality on the screen.

#### Mouse limiting
This setting determines the boundary of the mouse pointer within the edges of the screen. The options for this option are the same as for the Focus Limiter option.

#### Colour scheme
This option allows you to set different predefined colour schemes.
The option "Manage custom colour scheme..." affects the "custom" colour scheme. Here you can create your own colour scheme. In the settings you can also make a sub-selection of all available colour schemes, this way you only switch through colour schemes you really use.

It is also possible to select a colour scheme for a certain application. With NVDA+Control+P the current colour scheme is linked to the current application. Every time this application comes to the foreground, the colour scheme will be switched to this application.

#### Object Reader Mode
Object Reader Mode is a mode where NVDA and USA can be used more simply. With this mode, the voice is turned off by default and is only used for reading aloud. 
With USA you can also read out loud if the object is under the mouse. With NVDA+left-mouseclick this can be activated. USA then jumps automatically and a rectangle is drawn around the spoken word, if that is set.

### USA license
To use USA, you need a valid license code. Each license key can be used to activate USA up to three times.

If you have a valid licence code, you can enter it by choosing the option "license USA" within the "Ultimate Screen Access" menu.
In this window it is sufficient to enter the licence code and to choose OK, after which the licence will be activated. The licence can also be deactivated in the same way, e.g. if it is desirable to remove USA from the computer.

#### Offline Activation
USA offers an offline activation. With this the user can send their instance ID and license key to support@babbage.com. They will receive a unique activation hash and with that the USA license does not have to be checked online on that machine.

#### (BETA) Automatic Activation
USA offers an automatic activation. This is for "non-presistent" enviroments where USA activates itself every time it starts. It also attempts to deactive itself automatically.

## Hotkeys
Within USA, specific shortcuts have been assigned to adjust the magnification functionality and for the colour schemes.

The settings below can be adjusted via the NVDA menu. Choose "Options" and then "Input actions". The USA shortcuts can then be found under the category "Ultimate Screen Access".
For more information on how the Input Actions dialog box works, please refer to the NVDA manual.

Shortcut | Function
--------------------|--------------------------------------------------------------------------------
NVDA+alt+0 | Turns the magnifier on or off
Control + 0 | Turns the magnifier on or off
NVDA+alt+=  | increase the magnification factor
NVDA+alt+- | decrease the magnification factor
control+pageUp  | increase the magnification factor
control+pageDown | decrease the magnification factor
control+ Plus (+)  | increase the magnification factor
control+ minus (-) | decrease the magnification factor
NVDA+alt+arrow left | Scroll enlargement area to the left
NVDA+alt+arrow right | scroll zoom area to the right
NVDA+alt+arrow up | Scroll enlargement area up
NVDA+alt+down arrow | Scroll magnification area down
NVDA+alt+backspace | switches between the different colour schemes
control+backspace | switches between the different colour schemes
NVDA+alt+s | Enables or disables soft edges around images and text.
not connected | stop speech and disable browsemode if enabled. If the speech and browsemode is off.
not connected | Enables or disables word tracking.
NVDA+control+p | Set current colour scheme as default for foreground application.
NVDA+control+r | Read everything from the mouse


## Limitations and known issues
Ultimate Screen Access is continuously under development. It is therefore possible that some desired functionality is not (yet) available in the product. When using USA, please take into account the following known limitations:

* Within Internet Explorer the NVDA browsing mode is limited. Especially in long paragraphs, it will be noticeable that the enlargement does not fully follow the position of the cursor in scroll mode.
* Support for the use of multiple screens is very limited. When using multiple screens, we advise to set the leftmost screen as the main screen. In addition, it is necessary to adjust some boundary options in the USA settings from their default values
* Where NVDA offers the option of using a portable version, when using USA you should take into account the limitation that clicking with the mouse may not be accurate. When portable use of USA is strictly necessary, the advice is to set the mouse limitation to relative
* There are known problems where using soft borders around images causes the system to slow down, especially when using an NVIDIA branded video card.








